#include "thread_dumper.h"

static VALUE rb_mThreadDump;
static VALUE rb_cDumper;

static VALUE backtrace(rb_thread_t th)
{
  char buf[BUFSIZ];
  char buf2[BUFSIZ];
	char otherbuf[BUFSIZ];
  VALUE ary;
  NODE *n;
  struct FRAME *frame;

  n = th->node;
  frame = th->frame;
  ary = rb_ary_new();

  if (n) {
		if(nd_line(n) && n->nd_file){
	    snprintf(buf, BUFSIZ, "%s:%d", n->nd_file, nd_line(n));
	    rb_ary_push(ary, rb_str_new2(buf));			
		}
  } 

  return ary;
}


static VALUE
dump() 
{
  VALUE ary_dump;
  VALUE curr_rb_thread;
  struct rb_thread* curr_thread;
  struct rb_thread* th;

  ary_dump = rb_ary_new();
   
  curr_rb_thread = rb_thread_current();
  Data_Get_Struct(curr_rb_thread, struct rb_thread, curr_thread);

  if (curr_thread) {
    FOREACH_THREAD_FROM(curr_thread, th) {
      if (th) {
        rb_ary_push(ary_dump, backtrace(th));
      }
    } END_FOREACH_FROM(curr_thread, th);
  }

  return ary_dump;
}

void
Init_thread_dumper()
{
  rb_mThreadDump = rb_define_module("ThreadDump");
  rb_cDumper = rb_define_class_under(rb_mThreadDump, "Dumper", rb_cObject);
  rb_define_singleton_method(rb_cDumper, "dump", dump, 0);
}


